From cc5400eb7ea39e7503e0eb179d4cb77f5a60265d Mon Sep 17 00:00:00 2001
From: Thomas JUND <tjund@entrouvert.com>
Date: Fri, 8 Jan 2021 11:14:31 +0100
Subject: [PATCH] themes : use class 'site-nav' instead tag to select nav
 (#49976)

---
 static/amiens-metropole/_custom.scss           | 2 +-
 static/arpajon/_custom.scss                    | 2 +-
 static/calvados-cd14/_custom.scss              | 4 ++--
 static/calvados-intranet-cd14/_custom.scss     | 6 +++---
 static/castelnau-le-lez/_custom.scss           | 2 +-
 static/castries-2020/_custom.scss              | 2 +-
 static/castries/_custom.scss                   | 2 +-
 static/cinor/_custom.scss                      | 2 +-
 static/clapiers/_custom.scss                   | 2 +-
 static/clermont-metropole/_custom.scss         | 2 +-
 static/cnil/_custom.scss                       | 2 +-
 static/correze-cd19/_custom.scss               | 4 ++--
 static/fontenay-sous-bois-2018/_custom.scss    | 4 ++--
 static/gpseo/_custom.scss                      | 2 +-
 static/grand-chambery/_custom.scss             | 2 +-
 static/groupe-up/_custom.scss                  | 2 +-
 static/haute-garonne-cd31/_custom.scss         | 6 +++---
 static/hautes-alpes-2018/_custom.scss          | 2 +-
 static/hautes-alpes-2018/_neutral-variant.scss | 2 +-
 static/includes/_nav.scss                      | 8 ++++----
 static/la-reunion-region/_custom.scss          | 2 +-
 static/lambersart/_custom.scss                 | 2 +-
 static/lille-metropole/_custom.scss            | 4 ++--
 static/lille/_custom.scss                      | 2 +-
 static/lot-cd46/_custom.scss                   | 2 +-
 static/metz-metropole-2019/_custom.scss        | 2 +-
 static/minsant/_custom.scss                    | 2 +-
 static/moselle/_custom.scss                    | 2 +-
 static/murviel-les-montpellier/_custom.scss    | 2 +-
 static/pfwb/_custom.scss                       | 2 +-
 static/pre-saint-gervais/_custom.scss          | 2 +-
 static/roannais-agglomeration/_custom.scss     | 6 +++---
 static/saint-chamond/_custom.scss              | 4 ++--
 static/saint-denis/_custom.scss                | 4 ++--
 static/saint-laurent-du-var/_custom.scss       | 2 +-
 static/saint-lo-agglo/_custom.scss             | 2 +-
 static/saone-et-loire-cd71-2019/_custom.scss   | 2 +-
 static/seine-et-marne-apa/_custom.scss         | 2 +-
 static/signal-publik/_custom.scss              | 2 +-
 static/sussargues/_custom.scss                 | 2 +-
 static/toodego/_custom.scss                    | 6 +++---
 static/toulouse-metropole/_custom.scss         | 2 +-
 static/toulouse/_custom.scss                   | 4 ++--
 static/universite-paris-nanterre/_custom.scss  | 2 +-
 static/vendargues/_custom.scss                 | 2 +-
 static/venissieux/_custom.scss                 | 2 +-
 templates/theme.html                           | 2 +-
 47 files changed, 65 insertions(+), 65 deletions(-)

diff --git a/static/amiens-metropole/_custom.scss b/static/amiens-metropole/_custom.scss
index e09f8e6f..4f4d89af 100644
--- a/static/amiens-metropole/_custom.scss
+++ b/static/amiens-metropole/_custom.scss
@@ -1,7 +1,7 @@
 // Hide things the client asked
 
 a#publik-portal-agent,
-nav {
+.site-nav {
 	display: none;
 }
 
diff --git a/static/arpajon/_custom.scss b/static/arpajon/_custom.scss
index 2b1acc1d..56860432 100644
--- a/static/arpajon/_custom.scss
+++ b/static/arpajon/_custom.scss
@@ -77,7 +77,7 @@ div#main-content-wrapper {
 	}
 }
 
-body.has-picture nav::after {
+body.has-picture .site-nav::after {
 	top: 1px;
 }
 
diff --git a/static/calvados-cd14/_custom.scss b/static/calvados-cd14/_custom.scss
index b189ead2..d29235e4 100644
--- a/static/calvados-cd14/_custom.scss
+++ b/static/calvados-cd14/_custom.scss
@@ -122,7 +122,7 @@ body.has-picture {
 			}
 		}
 	}
-	nav::after {
+	.site-nav::after {
 		transition: all ease 0.2s;
 		top: calc(#{$toplinks-height} + #{$nav-padding} + #{$font-size * 3});
 		@media screen and ($max-mobile-viewport) {
@@ -154,7 +154,7 @@ body.scrolled {
 		padding-top: 0.5rem;
 	}
 
-	&.has-picture nav::after {
+	&.has-picture .site-nav::after {
 		top: calc(#{$nav-padding} + #{$font-size * 3});
 		@media screen and ($max-mobile-viewport) {
 			top: -16px;
diff --git a/static/calvados-intranet-cd14/_custom.scss b/static/calvados-intranet-cd14/_custom.scss
index 16c271a9..d235a1d5 100644
--- a/static/calvados-intranet-cd14/_custom.scss
+++ b/static/calvados-intranet-cd14/_custom.scss
@@ -216,15 +216,15 @@ div#nav {
 }
 
 // Picture
-body.has-picture nav::after {
+body.has-picture .site-nav::after {
 	top: 0;
 }
 @media ($min-desktop-viewport) {
-	body.has-picture nav::after {
+	body.has-picture .site-nav::after {
 		transition: top ease 0.2s;
 		top: calc(#{$toplinks-height} + #{$header-desktop-height});
 	}
-	body.has-picture.scrolled nav::after {
+	body.has-picture.scrolled .site-nav::after {
 		top: $header-desktop-fixed-height;
 	}
 }
diff --git a/static/castelnau-le-lez/_custom.scss b/static/castelnau-le-lez/_custom.scss
index 0bc9ba75..82eacc96 100644
--- a/static/castelnau-le-lez/_custom.scss
+++ b/static/castelnau-le-lez/_custom.scss
@@ -59,7 +59,7 @@ div#nav {
 	background: white url(img/bg_logo.png) top center no-repeat;
 }
 
-nav::after {
+.site-nav::after {
 	content: "";
 	display: block;
 	width: 100%;
diff --git a/static/castries-2020/_custom.scss b/static/castries-2020/_custom.scss
index 43fef833..1f805537 100644
--- a/static/castries-2020/_custom.scss
+++ b/static/castries-2020/_custom.scss
@@ -1,5 +1,5 @@
 div#page {
-	nav ul {
+	.site-nav ul {
 		margin-top: 0;
 	}
 }
diff --git a/static/castries/_custom.scss b/static/castries/_custom.scss
index 9a527a92..80004279 100644
--- a/static/castries/_custom.scss
+++ b/static/castries/_custom.scss
@@ -14,7 +14,7 @@ div#page {
 	margin: 0 auto;
 	box-shadow: 0 0px 2px rgba(0, 0, 0, 0.27);
 	border-radius: 2 * $border-radius;
-	.site-header, nav, #main-content-wrapper {
+	.site-header, .site-nav, #main-content-wrapper {
 		padding: 0 20px;
 		@media screen and ($max-mobile-viewport) {
 			padding: 0;
diff --git a/static/cinor/_custom.scss b/static/cinor/_custom.scss
index 71c19e34..4e6db3a5 100644
--- a/static/cinor/_custom.scss
+++ b/static/cinor/_custom.scss
@@ -143,7 +143,7 @@ div.gru-nav > ul ul {
 }
 
 // Page picture
-body.has-picture nav::after {
+body.has-picture .site-nav::after {
 	position: static;
 	max-width: $width;
 	margin-left: auto;
diff --git a/static/clapiers/_custom.scss b/static/clapiers/_custom.scss
index 8965bc3e..1eb979e7 100644
--- a/static/clapiers/_custom.scss
+++ b/static/clapiers/_custom.scss
@@ -41,7 +41,7 @@ body {
 	}
 }
 
-nav {
+.site-nav {
 	text-transform: uppercase;
 }
 
diff --git a/static/clermont-metropole/_custom.scss b/static/clermont-metropole/_custom.scss
index e2d2c044..2b33df84 100644
--- a/static/clermont-metropole/_custom.scss
+++ b/static/clermont-metropole/_custom.scss
@@ -247,7 +247,7 @@ div#footer {
 			display: none;
 		}
 	}
-	nav, #pwa-navigation {
+	.site-nav, #pwa-navigation {
 		display: none;
 	}
 	.pwa-navigation ~ footer {
diff --git a/static/cnil/_custom.scss b/static/cnil/_custom.scss
index 4e197a93..a4fe297b 100644
--- a/static/cnil/_custom.scss
+++ b/static/cnil/_custom.scss
@@ -58,7 +58,7 @@ body {
 	}
 }
 
-nav {
+.site-nav {
 	text-align: center;
 	font-family: $title-font-family;
 	@media screen and ($max-mobile-viewport) {
diff --git a/static/correze-cd19/_custom.scss b/static/correze-cd19/_custom.scss
index f41ab51e..46a27191 100644
--- a/static/correze-cd19/_custom.scss
+++ b/static/correze-cd19/_custom.scss
@@ -68,7 +68,7 @@ div#header {
 	}
 }
 
-nav {
+.site-nav {
 	z-index: 1000;
 }
 
@@ -109,7 +109,7 @@ div#main-content-wrapper {
 }
 
 // Page picture
-body.has-picture nav::after {
+body.has-picture .site-nav::after {
 	box-sizing: content-box;
 	position: static;
 	max-width: $width;
diff --git a/static/fontenay-sous-bois-2018/_custom.scss b/static/fontenay-sous-bois-2018/_custom.scss
index 23882e22..c997fda9 100644
--- a/static/fontenay-sous-bois-2018/_custom.scss
+++ b/static/fontenay-sous-bois-2018/_custom.scss
@@ -399,7 +399,7 @@ div#gauche {
 	.wcs-step {
 		margin-right: $wcs-steps-spacing;
 		flex: 1 1 auto;
-		max-width: 33%; 
+		max-width: 33%;
 		&:last-child {
 			flex-grow: 0;
 		}
@@ -544,7 +544,7 @@ div.back-home-button {
 	}
 }
 
-body.has-picture nav::after {
+body.has-picture .site-nav::after {
 	top: 0;
 }
 
diff --git a/static/gpseo/_custom.scss b/static/gpseo/_custom.scss
index f998fce6..080e33e8 100644
--- a/static/gpseo/_custom.scss
+++ b/static/gpseo/_custom.scss
@@ -230,7 +230,7 @@ div.gru-nav-wrapper {
 
 // Home image
 .page-index {
-	nav {
+	.site-nav {
 		width: 1920px;
 		max-width: 100%;
 		margin: 0 auto;
diff --git a/static/grand-chambery/_custom.scss b/static/grand-chambery/_custom.scss
index 7399d171..1a37612a 100644
--- a/static/grand-chambery/_custom.scss
+++ b/static/grand-chambery/_custom.scss
@@ -254,7 +254,7 @@ div#anomalies {
 	}
 }
 
-nav {
+.site-nav {
 	display: none;
 	@media screen and ($max-mobile-viewport) {
 		display: block;
diff --git a/static/groupe-up/_custom.scss b/static/groupe-up/_custom.scss
index 73d24db0..121915fd 100644
--- a/static/groupe-up/_custom.scss
+++ b/static/groupe-up/_custom.scss
@@ -77,7 +77,7 @@ body.anonymous-user {
 
 // navigation
 
-nav {
+.site-nav {
 	z-index: 5;
 }
 
diff --git a/static/haute-garonne-cd31/_custom.scss b/static/haute-garonne-cd31/_custom.scss
index 38575540..f76348fb 100644
--- a/static/haute-garonne-cd31/_custom.scss
+++ b/static/haute-garonne-cd31/_custom.scss
@@ -61,7 +61,7 @@ div#header h1#logo {
 	}
 }
 
-nav {
+.site-nav {
 	background: $primary-color;
 	#nav > ul {
 		margin-left: 180px;
@@ -113,7 +113,7 @@ nav {
 	}
 }
 
-body.has-picture nav::after {
+body.has-picture .site-nav::after {
 	top: 0;
 }
 
@@ -500,7 +500,7 @@ div#gauche {
 }
 
 @media screen and ($max-mobile-viewport) {
-	body.has-picture nav::after {
+	body.has-picture .site-nav::after {
 		height: 200px;
 		margin-top: -6px;
 	}
diff --git a/static/hautes-alpes-2018/_custom.scss b/static/hautes-alpes-2018/_custom.scss
index 59c50545..5c1d7e55 100644
--- a/static/hautes-alpes-2018/_custom.scss
+++ b/static/hautes-alpes-2018/_custom.scss
@@ -70,7 +70,7 @@ div#main-content-wrapper {
 		max-width: 100%;
 	}
 
-	> nav {
+	> .site-nav {
 		display: flex;
 		align-items: center;
 		justify-content: center;
diff --git a/static/hautes-alpes-2018/_neutral-variant.scss b/static/hautes-alpes-2018/_neutral-variant.scss
index ceb40e03..9fb63623 100644
--- a/static/hautes-alpes-2018/_neutral-variant.scss
+++ b/static/hautes-alpes-2018/_neutral-variant.scss
@@ -54,7 +54,7 @@ $margin-center: 0 auto;
 			}
 		}
 
-		nav {
+		.site-nav {
 			display: flex;
 
 			.user-nav {
diff --git a/static/includes/_nav.scss b/static/includes/_nav.scss
index 8cd05b85..0835a864 100644
--- a/static/includes/_nav.scss
+++ b/static/includes/_nav.scss
@@ -444,14 +444,14 @@ div.menucell {
 
 @if $nav-mobile-mode == bottom-bar {
 @media screen and (max-width: $nav-mobile-limit) {
-	nav {
+	.site-nav {
 		@include pwa-bottom-bar;
 	}
 	div#header h1 {  // cancel hamburger
 		padding-left: 0;
 		background-position: 0;
 	}
-	body.has-picture[data-picture] nav::after {
+	body.has-picture[data-picture] .site-nav::after {
 		content: none;
 	}
 	footer {
@@ -462,14 +462,14 @@ div.menucell {
 
 @if $nav-mobile-mode == hidden {
 	@media screen and (max-width: $nav-mobile-limit) {
-		nav {
+		.site-nav {
 			display: none;
 		}
 	}
 }
 
 @if $nav-after-image == true {
-	body.has-picture nav::after {
+	body.has-picture .site-nav::after {
 		content: "";
 		display: block;
 		width: 100%;
diff --git a/static/la-reunion-region/_custom.scss b/static/la-reunion-region/_custom.scss
index 141c430f..753d1ba8 100644
--- a/static/la-reunion-region/_custom.scss
+++ b/static/la-reunion-region/_custom.scss
@@ -81,7 +81,7 @@ div.gru-nav .gru-nav-button {
 		}
 	}
 }
-body.has-picture nav::after {
+body.has-picture .site-nav::after {
 	position: static;
 }
 
diff --git a/static/lambersart/_custom.scss b/static/lambersart/_custom.scss
index 8e1bd3ce..c9037e6d 100644
--- a/static/lambersart/_custom.scss
+++ b/static/lambersart/_custom.scss
@@ -70,7 +70,7 @@ div.gru-nav > ul {
 //
 // PAGE PICTURE
 //
-body.has-picture nav::after {
+body.has-picture .site-nav::after {
 	top: 0;
 }
 
diff --git a/static/lille-metropole/_custom.scss b/static/lille-metropole/_custom.scss
index d9b1248c..0399c028 100644
--- a/static/lille-metropole/_custom.scss
+++ b/static/lille-metropole/_custom.scss
@@ -103,7 +103,7 @@ body.has-picture {
 	}
 }
 
-body.has-picture nav::after {
+body.has-picture .site-nav::after {
 	top: 100px;
 }
 
@@ -152,7 +152,7 @@ body.has-picture nav::after {
 		width: auto;
 	}
 
-	body.has-picture nav::after {
+	body.has-picture .site-nav::after {
 		top: 0px;
 	}
 
diff --git a/static/lille/_custom.scss b/static/lille/_custom.scss
index c5f5dcae..50e55d9c 100644
--- a/static/lille/_custom.scss
+++ b/static/lille/_custom.scss
@@ -24,7 +24,7 @@ $form-picto-keywords: adresse, aquabike, archives, asso, attestation, bibliotheq
 	background: white;
 }
 
-nav {
+.site-nav {
 	z-index: 250;
 	pointer-events: none;
 	button, ul {
diff --git a/static/lot-cd46/_custom.scss b/static/lot-cd46/_custom.scss
index 27ed82fe..26886cfb 100644
--- a/static/lot-cd46/_custom.scss
+++ b/static/lot-cd46/_custom.scss
@@ -67,7 +67,7 @@ body.has-picture {
 		padding-top: 1rem;
 	}
 
-	nav::after {
+	.site-nav::after {
 		transition: all ease 0.2s;
 		top: -2rem;
 		@media screen and ($max-mobile-viewport) {
diff --git a/static/metz-metropole-2019/_custom.scss b/static/metz-metropole-2019/_custom.scss
index f094cecd..fb5df9df 100644
--- a/static/metz-metropole-2019/_custom.scss
+++ b/static/metz-metropole-2019/_custom.scss
@@ -123,7 +123,7 @@ button::-moz-focus-inner {
 	}
 }
 
-nav {
+.site-nav {
 	z-index: 250;
 	pointer-events: none;
 	button, ul {
diff --git a/static/minsant/_custom.scss b/static/minsant/_custom.scss
index a4bbd391..5df292a5 100644
--- a/static/minsant/_custom.scss
+++ b/static/minsant/_custom.scss
@@ -54,7 +54,7 @@
 	}
 }
 
-body.has-picture nav::after {
+body.has-picture .site-nav::after {
 	background-size: contain;
 }
 
diff --git a/static/moselle/_custom.scss b/static/moselle/_custom.scss
index 5a58a07a..5568cb90 100644
--- a/static/moselle/_custom.scss
+++ b/static/moselle/_custom.scss
@@ -52,7 +52,7 @@ div#main-content-wrapper {
 }
 
 body.has-picture {
-	nav::after {
+	.site-nav::after {
 		content: "";
 		display: block;
 		width: 100%;
diff --git a/static/murviel-les-montpellier/_custom.scss b/static/murviel-les-montpellier/_custom.scss
index 803ea0a3..62e72117 100644
--- a/static/murviel-les-montpellier/_custom.scss
+++ b/static/murviel-les-montpellier/_custom.scss
@@ -14,7 +14,7 @@ div#page {
 	max-width: $width;
 	margin: 0 auto;
 	box-shadow: 0 0px 2px rgba(0, 0, 0, 0.27);
-	.site-header, nav, #main-content-wrapper {
+	.site-header, .site-nav, #main-content-wrapper {
 		padding: 0 20px;
 		@media screen and ($max-mobile-viewport) {
 			padding: 0;
diff --git a/static/pfwb/_custom.scss b/static/pfwb/_custom.scss
index b6a50fee..75475e4c 100644
--- a/static/pfwb/_custom.scss
+++ b/static/pfwb/_custom.scss
@@ -171,7 +171,7 @@ body.has-picture {
 		width: auto;
 	}
 
-	body.has-picture nav::after {
+	body.has-picture .site-nav::after {
 		top: 0px;
 	}
 
diff --git a/static/pre-saint-gervais/_custom.scss b/static/pre-saint-gervais/_custom.scss
index af73aaee..ac35fc84 100644
--- a/static/pre-saint-gervais/_custom.scss
+++ b/static/pre-saint-gervais/_custom.scss
@@ -446,7 +446,7 @@ body.scrolled div.gru-nav > ul {
 	}
 }
 
-body.has-picture nav::after {
+body.has-picture .site-nav::after {
 	background-size: $width;
 	position: static;
 	margin-top: 160px;
diff --git a/static/roannais-agglomeration/_custom.scss b/static/roannais-agglomeration/_custom.scss
index f38bf1fa..503a27a8 100644
--- a/static/roannais-agglomeration/_custom.scss
+++ b/static/roannais-agglomeration/_custom.scss
@@ -80,12 +80,12 @@ footer {
 	}
 }
 
-nav ul {
+.site-nav ul {
 	margin: 0 auto;
 	text-align: center;
 }
 
-body.has-picture nav::after {
+body.has-picture .site-nav::after {
 	top: 0;
 }
 
@@ -222,7 +222,7 @@ div.cancel-button {
 }
 
 @media screen and (max-width: $nav-mobile-limit) {
-	body.has-picture nav::after {
+	body.has-picture .site-nav::after {
 		height: 200px;
 	}
 }
diff --git a/static/saint-chamond/_custom.scss b/static/saint-chamond/_custom.scss
index bb5bd704..ee4cec11 100644
--- a/static/saint-chamond/_custom.scss
+++ b/static/saint-chamond/_custom.scss
@@ -65,7 +65,7 @@ footer {
 	}
 }
 
-nav ul {
+.site-nav ul {
 	display: none;
 }
 
@@ -247,7 +247,7 @@ div.cancel-button {
 }
 
 @media screen and (max-width: $nav-mobile-limit) {
-	body.has-picture nav::after {
+	body.has-picture .site-nav::after {
 		height: 200px;
 	}
 }
diff --git a/static/saint-denis/_custom.scss b/static/saint-denis/_custom.scss
index 680830f2..f0e25559 100644
--- a/static/saint-denis/_custom.scss
+++ b/static/saint-denis/_custom.scss
@@ -22,7 +22,7 @@ div#header {
 	}
 }
 
-nav {
+.site-nav {
 	background-color: $tertiary-color;
 	margin-top: 25px;
 }
@@ -41,7 +41,7 @@ div.gru-nav {
 	}
 }
 
-body.has-picture nav::after {
+body.has-picture .site-nav::after {
 	background-image: var(--page-picture);
 	background-size: cover;
 	background-position: center;
diff --git a/static/saint-laurent-du-var/_custom.scss b/static/saint-laurent-du-var/_custom.scss
index 590c626e..50f8a621 100644
--- a/static/saint-laurent-du-var/_custom.scss
+++ b/static/saint-laurent-du-var/_custom.scss
@@ -138,7 +138,7 @@ div.gru-nav {
 	}
 }
 
-body.has-picture nav::after {
+body.has-picture .site-nav::after {
 	position: static;
 	width: $width;
 	max-width: 100%;
diff --git a/static/saint-lo-agglo/_custom.scss b/static/saint-lo-agglo/_custom.scss
index f279a3ac..b5014139 100644
--- a/static/saint-lo-agglo/_custom.scss
+++ b/static/saint-lo-agglo/_custom.scss
@@ -42,7 +42,7 @@ div#header h1#logo {
 	left: 0;
 }
 
-nav {
+.site-nav {
 	border-bottom: 5px solid #ccc;
 	@media screen and ($max-mobile-viewport) {
 		border: 0;
diff --git a/static/saone-et-loire-cd71-2019/_custom.scss b/static/saone-et-loire-cd71-2019/_custom.scss
index 4409b21c..88209a1b 100644
--- a/static/saone-et-loire-cd71-2019/_custom.scss
+++ b/static/saone-et-loire-cd71-2019/_custom.scss
@@ -281,7 +281,7 @@ div.back-home-button {
 	}
 }
 
-body.has-picture nav::after {
+body.has-picture .site-nav::after {
 	top: 0;
 }
 
diff --git a/static/seine-et-marne-apa/_custom.scss b/static/seine-et-marne-apa/_custom.scss
index fba02917..8bac8833 100644
--- a/static/seine-et-marne-apa/_custom.scss
+++ b/static/seine-et-marne-apa/_custom.scss
@@ -123,7 +123,7 @@ body.anonymous-user {
 
 // navigation
 
-nav {
+.site-nav {
 	z-index: 5;
 }
 
diff --git a/static/signal-publik/_custom.scss b/static/signal-publik/_custom.scss
index 19461100..80015c92 100644
--- a/static/signal-publik/_custom.scss
+++ b/static/signal-publik/_custom.scss
@@ -80,7 +80,7 @@
 	}
 }
 
-nav {
+.site-nav {
 	display: none;
 }
 
diff --git a/static/sussargues/_custom.scss b/static/sussargues/_custom.scss
index f37152b6..3bc1c480 100644
--- a/static/sussargues/_custom.scss
+++ b/static/sussargues/_custom.scss
@@ -13,7 +13,7 @@ div#page {
 	max-width: $width;
 	margin: 0 auto;
 	box-shadow: 0 0px 2px rgba(0, 0, 0, 0.27);
-	header, nav, #main-content-wrapper {
+	header, .site-nav, #main-content-wrapper {
 		padding: 0 20px;
 		@media screen and ($max-mobile-viewport) {
 			padding: 0;
diff --git a/static/toodego/_custom.scss b/static/toodego/_custom.scss
index c797ed94..4f7b7d78 100644
--- a/static/toodego/_custom.scss
+++ b/static/toodego/_custom.scss
@@ -20,7 +20,7 @@ body {
 	z-index: 1000;
 }
 
-.site-header, nav {
+.site-header, .site-nav {
 	background: white;
 }
 
@@ -910,7 +910,7 @@ div.wcs-tracking-code-input {
 		// different background to avoid mixing with navigation bar
 		background: #2e2e2e;
 	}
-	nav {
+	.site-nav {
 		height: $mobile-navigation-height;
 		position: fixed;
 		bottom: 0;
@@ -1101,7 +1101,7 @@ div.ui-widget-overlay {
 }
 
 @media screen and (max-width: $desktop-limit) {
-	body.focus-in nav {
+	body.focus-in .site-nav {
 		display: none;
 	}
 }
diff --git a/static/toulouse-metropole/_custom.scss b/static/toulouse-metropole/_custom.scss
index a88a8b7e..1d998276 100644
--- a/static/toulouse-metropole/_custom.scss
+++ b/static/toulouse-metropole/_custom.scss
@@ -74,7 +74,7 @@ header {
 	}
 }
 
-nav {
+.site-nav {
 	position: fixed;
 	height: 100%;
 	top: 0;
diff --git a/static/toulouse/_custom.scss b/static/toulouse/_custom.scss
index e9309b6f..20e0c96b 100644
--- a/static/toulouse/_custom.scss
+++ b/static/toulouse/_custom.scss
@@ -109,7 +109,7 @@ a:hover {
 	}
 }
 
-nav {
+.site-nav {
 	position: fixed;
 	height: $intro-height;
 	top: $header-height;
@@ -1773,7 +1773,7 @@ div#rub_service div#info {
 }
 
 .authentic-page {
-	.site-header, nav, div#actu {
+	.site-header, .site-nav, div#actu {
 		display: none;
 	}
 	div#page {
diff --git a/static/universite-paris-nanterre/_custom.scss b/static/universite-paris-nanterre/_custom.scss
index 52db2671..44b07a93 100644
--- a/static/universite-paris-nanterre/_custom.scss
+++ b/static/universite-paris-nanterre/_custom.scss
@@ -92,6 +92,6 @@ div.textcell {
 	}
 }
 
-body.has-picture nav::after {
+body.has-picture .site-nav::after {
 	top: -12px;
 }
diff --git a/static/vendargues/_custom.scss b/static/vendargues/_custom.scss
index 941ee2b1..45db6cc5 100644
--- a/static/vendargues/_custom.scss
+++ b/static/vendargues/_custom.scss
@@ -15,7 +15,7 @@ div#header {
 	}
 }
 
-nav {
+.site-nav {
 	text-transform: uppercase;
 }
 
diff --git a/static/venissieux/_custom.scss b/static/venissieux/_custom.scss
index b947ae65..0bafccfe 100644
--- a/static/venissieux/_custom.scss
+++ b/static/venissieux/_custom.scss
@@ -1,7 +1,7 @@
 @import '../includes/fonts/oswald';
 @import '../includes/fonts/cantarell';
 
-nav {
+.site-nav {
 	display: none;
 }
 
diff --git a/templates/theme.html b/templates/theme.html
index d5ea3817..b5b9410d 100644
--- a/templates/theme.html
+++ b/templates/theme.html
@@ -80,7 +80,7 @@
     </header>
 
 {% block nav %}
-<nav role="navigation">
+<nav role="navigation" class="site-nav">
 <div id="nav-wrapper" class="gru-nav-wrapper">
 {% block nav-pre %}{% endblock %}
 <div id="nav" class="gru-nav togglable">
-- 
2.20.1